package SDK

// 表单
type Device_Form struct {
	T_ProductID string  // Sn
	T_sn        string  // 标签路径
	T_online    int     // 当前页码
	PageIndex   int     // 当前页码
	PageSize    int     // 每页文档数量
}

// 表单
type DeviceData_Form struct {
	T_sn       string  // Sn
	T_jointTab string  // 标签路径
	T_jsonFind string  // 条件
	T_jsonSort string  // 排序
	PageIndex  int     // 当前页码
	PageSize   int     // 每页文档数量
}

type JSONR struct {
	//必须的大写开头
	Code int16
	Msg  string
	Data interface{} // 泛型
}
type JSONS_Device struct {
	//必须的大写开头
	Code int16
	Msg  string
	List      []Device
	Total     int16
	PageIndex int
	PageSize  int
}
type JSONS_Data struct {
	//必须的大写开头
	Code int16
	Msg  string
	List      []interface{}
	Total     int16
	PageIndex int
	PageSize  int
}
// 产品协议
type ProductMode struct {
	Id         int    `json:"Id"`
	T_name     string `json:"T_name"`     // 协议名称  Mqtt
	T_address  string `json:"T_address"`  //接入地址    bj-3-mqtt.iot-api.com:1883
	T_describe string `json:"T_describe"` // 描述内容
	T_state    int    `json:"T_state"`    //状态
}

// 产品类型
type ProductType struct {
	T_ProductID     string                   `orm:"size(8);pk" json:"T_ProductID" form:"T_ProductID"`               // 产品型号 随机生成（8位）
	T_uuid          string                   `orm:"size(8);index" json:"T_uuid" form:"T_uuid"`                      // 用户识别码（8位） ，管理员可以为空
	T_name          string                   `orm:"size(256);" json:"T_name" form:"T_name"`                         // 产品名称
	T_img           string                   `orm:"size(200);" json:"T_img" form:"T_img"`                           // 图片
	T_akey          string                   `orm:"size(56);" json:"T_akey" `                                       // 授权密钥
	T_prot          int                      `orm:"size(10);default(0)" json:"T_prot" form:"T_prot"`                //接入协议ID  0：统一协议
	T_TabData       string                   `orm:"type(text);default('{}')" json:"T_TabData" form:"T_TabData"`     // 产品模型
	T_TabDataJson   []map[string]interface{} `orm:"-" json:"T_TabDataJson"`                                         // 产品模型 json
	T_RelayData     string                   `orm:"type(text);default('{}')" json:"T_RelayData" form:"T_RelayData"` // 消息转发
	T_RelayDataJson map[string]interface{}   `orm:"-" json:"T_RelayDataJson"`                                       // 消息转发 json
	CreateTime      Time                     `orm:"column(create_time);type(timestamp);auto_now_add" json:"CreateTime"`
	UpdateTime      Time                     `orm:"column(update_time);type(timestamp);auto_now" json:"UpdateTime"`
}
// 产品协议
type ProductProt struct {
	Id      int    `orm:"column(ID);size(11);auto;pk" json:"Id" form:"Id"`
	T_uuid string `orm:"size(8);index" json:"T_uuid" form:"T_uuid"`    // 用户识别码（8位） ，管理员可以为空
	T_name  string `orm:"size(256);" json:"T_name" form:"T_name"`         // 协议名称
	T_mode  int    `orm:"size(1);default(0)" json:"T_mode" form:"T_mode"` //接入方式  0：Mqtt  1：http  2:tcp  3:CoAP  4:websocket
	//T_prot     int    `orm:"size(1);default(0)" json:"T_Prot" form:"T_prot"`                              //接入协议ID  0：统一协议
	T_lang     int    `orm:"size(1);default(1)" json:"T_lang" form:"T_lang"`                                  //编程语言 0: 无解析 1: go   2: C
	T_analysis string `orm:"size(100);default('')" json:"T_analysis" form:"T_analysis"` //数据解析
	T_text     string `orm:"type(text);default('')" json:"T_text" form:"T_text"`                              // 代码内容
	T_describe string `orm:"type(text);default('')" json:"T_describe" form:"T_describe"`                      // 描述内容
	//T_reply    string `orm:"size(100);default(_reply)" json:"T_reply" form:"T_reply"`                       //返回后缀  _reply

}
// 设备
type Device struct {
	T_sn          string                 `orm:"size(256);pk" json:"T_sn" form:"T_sn"`                     // Sn
	T_password    string                 `orm:"size(256);" json:"T_password" form:"T_password"`           // 密码
	T_online      int                    `orm:"size(1);index;default(3)" json:"T_online" form:"T_online"` // 在线状态  1 在线  2 离线   3 未激活
	T_project     string                 `orm:"size(256);default('')" json:"T_project" form:"T_project"`  // 项目地址
	T_ProductID   string                 `orm:"size(8);index" json:"T_ProductID" form:"T_ProductID"`      // 产品类型
	T_ProductJson ProductType            `orm:"-" json:"T_ProductJson"`                                   // 产品类型 json
	T_data        string                 `orm:"column(t_data);type(text);default('')" json:"T_data" `     // 设备数据
	T_dataJson    map[string]interface{} `orm:"-" json:"T_dataJson"`                                      // 设备数据
	T_state       int                    `orm:"size(2);default(1);index" json:"T_state" form:"T_state"`   //  1 正常  2 禁用\删除   3 无效
	CreateTime    Time                   `orm:"column(create_time);type(timestamp);auto_now_add" json:"CreateTime"`
	UpdateTime    Time                   `orm:"column(update_time);type(timestamp);auto_now" json:"UpdateTime"`
}

